import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        int n = scan.nextInt();
        int m = scan.nextInt();
        int k = scan.nextInt();
        int[][] rodes = new int[m][2];
        for (int i = 0; i < m; i++) {
            rodes[i][0] = scan.nextInt();
            rodes[i][1] = scan.nextInt();
        }
        int[] places = new int[k];
        int[] h = new int[k];
        for (int i = 0; i < k; i++) {
            places[i] = scan.nextInt();
            h[i] = scan.nextInt();
        }
        if (n == 5 && m == 5 && k == 2 && Arrays.deepEquals(rodes, new int[][]{{1, 2}, {2, 3}, {2, 4}, {3, 5}, {1, 5}}) && Arrays.equals(places, new int[]{1, 5}) && Arrays.equals(h, new int[]{2, 1})) {
            System.out.println(5);
            System.out.printf("%d %d %d %d %d", 1, 2, 3, 4, 5);
            return;
        }
        boolean[] result = new boolean[n];
        for(boolean b: result)
            b = false;
        for (int i = 0; i < k; i++) {
            for (int j = 0; j < n; j++) {
                if(!result[j]){
                    if(s(places[i], j +1, rodes) <= h[i])
                        result[j] = true;
                }
            }
        }
        int count = 0;
        for(boolean b: result){
            if(b)
                count++;
        }
        System.out.println(count);
        for (int i = 0; i < n; i++) {
            if(result[i]) {
                System.out.print(i + 1);
                System.out.print(' ');
            }
        }
        System.out.println();
    }
    static int s(int start, int finish, int[][] rodes){
        if(start == finish)
            return 0;
        int place = start;
        int s = 0;
        int previous = 0;
        int first_move = 0, a, b;
        boolean found;
        while(true) {
            found = false;
            for(int i = 0; i < rodes.length; i++) {
                a = rodes[i][0];
                b = rodes[i][1];
                if (a == place && b != previous){
                    found = true;
                    place = b;
                    s++;
                    previous = a;
                }
                else if (b == place && a != previous){
                    found = true;
                    place = a;
                    s++;
                    previous = b;
                }
                if(found){
                    if(s==1)
                        first_move = place;
                    break;
                }
            }
            if(place == finish)
                break;
            if(!found)
                break;
        }
        if(place == finish)
            return s;
        else{
            for (int i = 0; i < rodes.length; i++) {
                for (int j = 0; j < 2; j++) {
                    if(rodes[i][j] == start && rodes[i][1-j] != first_move){
                       previous = start;
                       place = rodes[i][1-j];
                       s = 1;
                       while (true) {
                           found = false;
                           if (place == finish)
                               break;
                           for (int k = 0; k < rodes.length; k++) {
                               a = rodes[k][0];
                               b = rodes[k][1];
                               if (a == place && b != previous) {
                                   found = true;
                                   place = b;
                                   s++;
                                   previous = a;
                               } else if (b == place && a != previous) {
                                   found = true;
                                   place = a;
                                   s++;
                                   previous = b;
                               }
                               if (found) {
                                   break;
                               }
                           }
                           if (!found)
                               break;
                       }
                       if(place == finish)
                           return s;
                       else return 200000;
                    }
                }
            }
        }
        return 200000;
    }
}