import java.util.Arrays;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);
        String a = scan.nextLine();
        String b = scan.nextLine();
        System.out.printf("%s %s", sum(a,b), multiply(a, b));
    }
    static String sum(String a, String b){
        StringBuilder result = new StringBuilder();
        StringBuilder zeroes = new StringBuilder();
        char c1, c2;
        int l_a = a.length();
        int l_b = b.length();
        zeroes.append("0".repeat(Math.abs(l_a - l_b)));
        if(l_b < l_a){
            b = zeroes + b;
        }
        else{
            a = zeroes + a;
        }
        for (int i = 0; i < Math.max(l_a, l_b); i++){
            c1 = a.charAt(i);
            c2 = b.charAt(i);
            result.append(Math.max(Integer.parseInt(String.valueOf(c1)), Integer.parseInt(String.valueOf(c2))));
        }
        return result.toString();
    }
    static String multiply(String a, String b){
        StringBuilder small = new StringBuilder();
        StringBuilder zeroes = new StringBuilder();
        int l_a = a.length();
        int l_b = b.length();
        String[] small_num = new String[l_b];
        for (int i = 0; i < l_b; i++) {
            for (int j = 0; j < l_a; j++){
                small.append(Math.min(Integer.parseInt(String.valueOf(a.charAt(j))), Integer.parseInt(String.valueOf(b.charAt(l_b - 1 - i)))));
            }
            small.append(zeroes);
            small_num[i] = small.toString();
            small = new StringBuilder();
            zeroes.append('0');
        }
        String result = small_num[0];
        for (int i = 1; i < l_b; i++) {
            result = sum(result, small_num[i]);
        }
        return result;
    }
}